const loader = document.querySelector('.loading');
const countryName = document.getElementById('name')
const region = document.getElementById('region')
const subregion = document.getElementById('subregion')
const capital = document.getElementById('capital')
const flag = document.getElementById('flag')
const button = document.getElementById('show')
const userInput = document.getElementById('country_name')
const infoToshow = document.querySelector('.show');
let name_to_find = 'Kazakhstan'


const request = (config) => {
    loader.style.display = 'flex'
    const { method, path, success, error } = config;
    return new Promise((resolve, reject) => {
        const xml = new XMLHttpRequest();
        xml.addEventListener('load', () => {
            if (xml.status >= 200 || xml.status > 300) {
                const result = JSON.parse(xml.responseText);
                resolve(result)
            }
            else {
                reject(this.status)
            }
        });
        loader.style.display = 'none'
        xml.addEventListener('error', () => {
            error('network error');
        })
        xml.addEventListener('timeout', () => {
            error('server response is late')
        })
        xml.open(method, path);
        xml.send();
    })
}

const processResultMainCountry = (result) => { // result - данные полученые от первого запроса хранят в себе страну и ее данные.
    const h2 = document.createElement('h2') // создаем элемент чтобы добавить название основной страны в заголовок
    h2.innerText = result[0].name
    const ul = document.createElement('ul')
    infoToshow.append(h2)
    const names =  result[0]['borders'].map( item => { // здесь создаем и записываем все промисы которые позже запустим в Promise.all
        return request({                                        
            method: 'GET',
            path: `https://restcountries.com/v3.1/alpha/${item}` // каждый item - это код страны. Мы тут еще не вызываем запрос,
                                                                 // только записываем в массив
        })});
        borderCountry = Promise.all(names) // здесь уже вызываем все запросы по границам, получаем опять массив
        .then( data => {
            data.forEach(element => {
                const li = document.createElement('li')
                li.innerText = element[0].name.common // получаем стандартное имя страны
                ul.append(li)

            });
        })
        infoToshow.append(ul)
        loader.style.display = 'none'
    }
    




const errorHandler = (msg) => {
    alert(msg)
    console.error(msg)
}

// const createTree = (data) => {
//     const ul = document.createElement('ul')
//     for (item in data) {
//         const li = document.createElement('li')
//         if (false) {
//             const flagImg = document.createElement('img');
//             flagImg.setAttribute('src', `${item.flag}`);
//             flagImg.style = 'width: 150px'
//             li.append(flagImg)
//         }
//         else {
//             if (Array.isArray(data)) {
//                 if (typeof data[item] === 'object') {
//                     const innerUl = createTree(data[item])
//                     li.append(innerUl)
//                 } else {
//                     li.append(`${data[item]}`)
//                 }
//             } else {
//                 if (Array.isArray(data[item])) {
//                     li.innerHTML = `<b>${item}:</b> \n`
//                     const innerUl = createTree(data[item])
//                     li.append(innerUl)
//                 } else {
//                     if ((typeof data[item] === 'object')) {
//                         li.innerHTML = `<b>${item}:</b> \n`
//                         const innerUl = createTree(data[item])
//                         li.append(innerUl)
//                     } else {
//                         li.innerHTML = `<b>${item}:</b> ${data[item]}`
//                     }

//                 }
//             }
//         }

//         ul.append(li)

//     }
//     return ul
// }



const showInfo = () => {
    if (userInput.value) {
        name_to_find = userInput.value
    }
    const config = {
        method: "GET",
        path: `https://restcountries.com/v2/name/${name_to_find}`,

    }
    request(config)
        .then(processResultMainCountry)
        .catch(errorHandler)

    infoToshow.style.display = 'block'
}
button.addEventListener('click', showInfo)
